package nerr

// 成功返回
const OK uint32 = 200

/** 前3位标识业务，后3位标识具体功能 **/

// 全局错误

const (
	ServerCommonError uint32 = iota + 100001
	RequestParamError
	TokenExpireError
	TokenGenerateError
	DBError
	DBUpdateAffectedZeroError
	CopyError
)

// 业务错误

const (
	// UserAlreadyCheckIn 用户相关
	UserAlreadyCheckIn uint32 = iota + 200100 // 用户已打过卡了

	// UserIntegralNotEnoughError 用户积分相关 UserIntegral
	UserIntegralNotEnoughError // 用户积分不足
	NewUserIntegralError       // 新建用户积分失败
	GetUserIntegralError       // 获取用户积分失败
	UpdateUserIntegralError    // 更新用户积分失败

	// UserCoinNotEnoughErr 用户金币(Coin)相关 UserCoin
	UserCoinNotEnoughErr // 用户金币不足
	NewUserCoinErr       // 新建用户金币失败
	GetUserCoinErr       // 获取用户金币失败
	UpdateUserCoinErr    // 更新用户金币失败

	// UserEliteExpiresErr 用户精英单位相关
	UserEliteExpiresErr    // 用户精英单位过期
	UserEliteNotFoundErr   // 用户没有此单位
	UserChangeEliteErr     // 用户切换精英单位失败
	UserBuyDefaultEliteErr // 用户购买默认精英单位(不允许的事)

	// UserTitleExpiresErr 用户称号相关
	UserTitleExpiresErr  // 用户称号过期
	UserTitleNotFoundErr // 用户没有此称号
	UserChangeTitleErr   // 用户切换称号失败
)

// 其它业务

const (
	// GiftPackHasDrawError 礼包相关 GiftPack
	GiftPackHasDrawError          uint32 = iota + 201100 // 该礼包已经领取过
	GiftPackDrawCountLimitedError                        // 该礼包已领取完

	// GiftRecordErr 礼物相关 Gift
	GiftRecordErr         // 礼物记录失败
	GiftNobilityUpdateErr // 更新贵族信息失败

	// RankStatisticsSelectError 排行相关
	RankStatisticsSelectError // 获取统计数据失败
	RankSubmitErr             // 结算失败
	RankNotEnabled            // 排行榜功能未开启
	RankNotExists             // 排行榜不存在

	// EliteConfigNotFoundErr 精英单位
	EliteConfigNotFoundErr // 精英单位配置不存在

	// TitleConfigNotFoundErr 称号相关
	TitleConfigNotFoundErr // 称号配置不存在
	TitleCannotBuyErr      // 该称号禁止购买
)
